void dma(int taille, char* dest,int wr)
{
    char c;
    out(0x14,8);
    if (wr) out(0x5a,0x0b); else out(0x56,0x0b);
    c=(char)((unsigned long)dest & 0x0000FF);
    out(c,0x0c);  //reset le ship dma
    out(c,4);
    c=(char)(((unsigned long)dest & 0x00ff00)>>8);
    out(c,4);
    c=(char)(((unsigned long)dest & 0xff0000)>>16);
    out(c,0x81);
    out(c,0x0c);
    out(0xff,5);
    c=(char) ((2*taille-1) & 0xff);
    out(c,5);
    out(2,0x0a);
    out(0x10,8);
}
    
void mrqloop()
{
    while((in(0x3f4) & 0xc0) != 0x80);
}

void mrqloop2()
{
    while((in(0x3f4) & 0xc0) != 0xc0);
}   

void busyloop()
{
    while((in(0x3f4) & 0x10) == 0x10);
}

void disk_on()
{
    out(0x1c,0x3f2);
}

void disk_off()
{
    out(0,0x3f2);
}

void get_from_disk(int cyl, int sect, int tete, int taille, char* dest)
{
    char c;
    int i;
    disk_on();
    mrqloop();
    dma(taille,dest,0);
    mrqloop();
    out(0x66,0x3f5);
    mrqloop();
    out(0x0,0x3f5);
    mrqloop();
    c=(char)(cyl & 0xFF);
    out(c,0x3f5);
    mrqloop();
    c=(char)(tete & 0xff);
    out(c,0x3f5);
    mrqloop();
    c=(char)(sect & 0xff);
    out(c,0x3f5);
    mrqloop();
    out(2,0x3f5);
    mrqloop();
    c=(char)(taille & 0xff);
    out(c,0x3f5);
    mrqloop();
    out(27,0x3f5);
    mrqloop();
    out(0xff,0x3f5);
    for(i=0; i<7;i++)
    {
	mrqloop2();
	c=in(0x3f5);
    }
    busyloop();   
    disk_off();
}
