.org 0
zero:
jmp start
chaine:
.ascii "Hum, j'ai un peu plus de place, je vais donc passer en mode protege"
.byte 13,10,0
readsector:
.byte 0x66,0x0,0x0,0x0,0x02,0x2,10,27,0xff,0xfe
dat:
.byte 0,0,0,0,0,0,0
.byte 0,0,0
point:
.byte 46,0
adresse:
.word 0,0

start:
    
    mov ax, #0x0e00
    mov ds, ax
    mov es, ax
    mov ax, #chaine
    call print
    
    
    jmp suite

suite:
    
    mov ax,#0xb800
    mov ds,ax
    mov si,#2
;    movb [si],#0x3a
    inc si
    inc si
 ;   movb [si],#0x29
    
    mov ax,#0x0e00
    mov ds,ax
	
;    mov ah,#0		; attend une touche
;    int #0x16



 
    MOV AL,#0xff            ; Interdit toute interruption
    OUT #0xa1,AL
    call delay
    
    MOV AL,#0xfb
    OUT #0x21,AL

    call delay
    
     
    
    
    
    
    
    
    lidt idt_48
    lgdt gdt_48

    cli


    call empty_8042

    movb    al, #0xD1                      ; command write
    outb    #0x64,al
    call    empty_8042

    movb    al,#0xDF                      ; A20 on
    outb    #0x60,al
    call    empty_8042
    
    
    mov ax,#1
    lmsw ax
    jmp flush_instr

flush_instr:

    xor    bx, bx                        ; Flag to indicate a boot
    xor    esi, esi                      ; Pointer to real-mode code
    mov    si, cs
    sub    si,#0x0020
    shl    esi,#4            

    mov ax,#0x18
    mov ds,ax
    mov esi,#0xb8000
    movb [esi],#0x3a


#bou:
#    jmp bou
    


    .byte 0x66,0xea

code32:    
    .long 0xe200
    .word 0x10


    ret





ennd:
jmp ennd

delay:
    outb    #0x80,al
    ret

empty_8042:
    push   ecx
    mov    ecx,#100000
    
empty_8042_loop:
    dec     ecx
    jz      empty_8042_end_loop

    call    delay

    inb     al,#0x64                      ;# 8042 status port
    testb   al,#1                         ;# output buffer?
    jz      no_output

    call    delay
    inb     al,#0x60                      ;# read it
    jmp     empty_8042_loop

no_output:
    testb   al,#2                     ;    # is input buffer full?
    jnz     empty_8042_loop            ;     # yes - loop

empty_8042_end_loop:
    pop    ecx
    ret

.org 256
gdt:
.word 0,0,0,0
.word 0,0,0,0
.word 0xffff,0,0x9a00,0x00cf
.word 0xffff,0,0x9200,0x00cf

idt_48:
.word 0,0,0

gdt_48:
.word 0x0400
.long 0x0000e100


print:
    push ax
    push si
    push bx
    mov si, ax
bcl:
    cmpb [si],#0
    je fin
    mov ah,#0x0e
    mov al, [si]
    mov bl, #0
    int #0x10
    inc si
    jmp bcl

fin:

    pop bx
    pop si
    pop ax
    ret


readdata:
    mov si,ax
    mov cx,#7

bcl3:
    cmp cx,#0
    je fin3
    call mrqloop2
    in al,dx
    mov [si],al
    inc si
    dec cx
    jmp bcl3

fin3:

    ret


data:
    
    mov si, ax
bcl2:
    cmpb [si],#0xfe
    je fin2
    movb al,[si]
    call mrqloop
    out dx,al
    inc si
    jmp bcl2

fin2:

    ret


mrqloop2:
    push ax
    push bx
    push dx
mrqlop2:    
    mov dx,#0x3f4
    in al,dx
    and al,#0xc0
    cmp al,#0xc0
    jne mrqlop2
    pop dx
    pop bx
    pop ax
    ret		    


mrqloop:

    push ax
    push dx
mrqlop:
    
    mov dx,#0x3f4
    in al,dx
    and al,#0xc0
    cmp al,#0x80
    jne mrqlop
    
    pop dx
    pop ax
    
    ret		    

dma:

disable_dma1:          ; disable DMA 1

mov     al, #0x14    ; output 14h to the command register to disable and
out     #0x08, al    ; initialise the DMA controller

mode:                  ; set up DMA transfer mode for channel 2
mov     al, #0x56    ; set  up for a single write transfer to main memory
out     #0x0b, al    ; using DMA channel 2
; for a read, output 5ah

get_address:           ; get the buffer address, and split into component parts
; as required by the DMA controller.
mov     ax, es     ; load buffer segment into AX
mov     cl, #0x04    ;
shl     ax, cl     ; shift value in ax left 4 times
add     ax, bx     ; add offest + buffer. AX now contains high and low 
; for the DMA address register.
jc      carry      ; if carry is set, jump to carry

no_carry:
mov     bx, es     ; load segment of buffer into BX
mov     cl, #0x04    ;
shr     bh, cl     ; shift right BH 4 times. BH now contains the value
; for the DMA page segment
jmp  buffer_address; output the buffer address

carry:
mov     bx, es     ; load segment of buffer into BX
mov     cl, #0x04    ;
shr     bh, cl     ; shift right BH 4 times.  BH now contains the high
; bits of the segment
adc     bh, #0x00

buffer_address:        ; output the address to the DMA controller
out     #0x0c, al    ; reset flip-flop. I am not sure what this does,
; but my reference shows this as necessary.
out     #0x04, al    ; output low order address byte to address register
mov     al, ah     ;
out     #0x04, al    ; output high-order address byte to address register
mov     al, bh     ;
out     #0x81, al    ; load page register with page value

count:                 ; set up count register
out     #0x0c, al    ; reset flip-flop
mov     al, #0xff   ;
out     #0x05, al    ;
mov     al, #0x01    ;
out     #0x05, al    ; load 511 into count register (to read one sector)
; it should be noted that for multiple transfers, the
; second value output to port 05h is equivalent to
; (2*number of sectors)-1
release_channel:
mov     al, #0x02
out     #0x0a, al    ; release channel 2

enable_dma1:           ; enable DMA 1
mov     al, #0x10
out     #0x08, al   ; this is the value for enabling the DMA for the mode required

ret



.org 512


;start32:

;    db 0x66,0xea
;    dd 0x00008200
;    dw 0x0010
    
;    jmp start32
;    mov eax,#0x18
;    mov ds,ax
;    mov es,ax
;    mov fs,ax
;    mov gs,ax
;    mov ss,ax
;    mov esi,#0xb8002
;    movb [esi],#0x3a
    
;fin32:
;    jmp fin32


